/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractCalendar;
import java.util.TimeZone;
import org.richfaces.model.CalendarDataModel;

/**
 *  @author amarkhel
 

 **/
@Generated({"RichFaces CDK", "4.0.0-SNAPSHOT"})
public class UICalendar extends AbstractCalendar
    implements ClientBehaviorHolder
    {

    public static final String COMPONENT_TYPE="org.richfaces.Calendar";

    public static final String COMPONENT_FAMILY="org.richfaces.Calendar";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public UICalendar() {
        super();
        setRendererType("org.richfaces.CalendarRenderer");
    }

    private static final Collection<String> EVENT_NAMES = Collections.unmodifiableCollection(Arrays.asList(
        "datemouseover",
        "inputblur",
        "beforetimeselect",
        "inputmouseover",
        "inputselect",
        "inputkeydown",
        "dateselect",
        "beforecurrentdateselect",
        "inputmouseup",
        "inputdblclick",
        "currentdateselect",
        "inputchange",
        "inputkeyup",
        "inputclick",
        "inputmousemove",
        "complete",
        "hide",
        "show",
        "clean",
        "inputfocus",
        "inputkeypress",
        "inputmouseout",
        "datemouseout",
        "timeselect",
        "inputmousedown",
        "change",
        "beforedateselect"

        ));
    
    public Collection<String> getEventNames() {
        return EVENT_NAMES;
    }


    public String getDefaultEventName() {
        return null;
    }

    protected static enum Properties {
        boundaryDatesMode,
        buttonClass,
        buttonIcon,
        buttonIconDisabled,
        buttonLabel,
        currentDate,
        dataModel,
        datePattern,
        dayClassFunction,
        dayDisableFunction,
        defaultTime,
        direction,
        disabled,
        enableManualInput,
        firstWeekDay,
        hidePopupOnScroll,
        horizontalOffset,
        inputClass,
        inputSize,
        inputStyle,
        jointPoint,
        minDaysInFirstWeek,
        mode,
        monthLabels,
        monthLabelsShort,
        onbeforecurrentdateselect,
        onbeforedateselect,
        onbeforetimeselect,
        onchange,
        onclean,
        oncomplete,
        oncurrentdateselect,
        ondatemouseout,
        ondatemouseover,
        ondateselect,
        onhide,
        oninputblur,
        oninputchange,
        oninputclick,
        oninputdblclick,
        oninputfocus,
        oninputkeydown,
        oninputkeypress,
        oninputkeyup,
        oninputmousedown,
        oninputmousemove,
        oninputmouseout,
        oninputmouseover,
        oninputmouseup,
        oninputselect,
        onshow,
        ontimeselect,
        popup,
        preloadDateRangeBegin,
        preloadDateRangeEnd,
        resetTimeOnDateSelect,
        showApplyButton,
        showFooter,
        showHeader,
        showInput,
        showWeekDaysBar,
        showWeeksBar,
        style,
        tabindex,
        timeZone,
        todayControlMode,
        verticalOffset,
        weekDayLabels,
        weekDayLabelsShort,
        zindex

    }


 
    public String getBoundaryDatesMode() {
        return (String) getStateHelper().eval(Properties.boundaryDatesMode, "inactive");
    }
    
    public void setBoundaryDatesMode(String boundaryDatesMode) {
        getStateHelper().put(Properties.boundaryDatesMode, boundaryDatesMode);
    }

 
    public String getButtonClass() {
        return (String) getStateHelper().eval(Properties.buttonClass);
    }
    
    public void setButtonClass(String buttonClass) {
        getStateHelper().put(Properties.buttonClass, buttonClass);
    }

 
    public String getButtonIcon() {
        return (String) getStateHelper().eval(Properties.buttonIcon);
    }
    
    public void setButtonIcon(String buttonIcon) {
        getStateHelper().put(Properties.buttonIcon, buttonIcon);
    }

 
    public String getButtonIconDisabled() {
        return (String) getStateHelper().eval(Properties.buttonIconDisabled);
    }
    
    public void setButtonIconDisabled(String buttonIconDisabled) {
        getStateHelper().put(Properties.buttonIconDisabled, buttonIconDisabled);
    }

 
    public String getButtonLabel() {
        return (String) getStateHelper().eval(Properties.buttonLabel);
    }
    
    public void setButtonLabel(String buttonLabel) {
        getStateHelper().put(Properties.buttonLabel, buttonLabel);
    }

 
    public Object getCurrentDate() {
        return (Object) getStateHelper().eval(Properties.currentDate);
    }
    
    public void setCurrentDate(Object currentDate) {
        getStateHelper().put(Properties.currentDate, currentDate);
    }

 
    public org.richfaces.model.CalendarDataModel getDataModel() {
        return (CalendarDataModel) getStateHelper().eval(Properties.dataModel);
    }
    
    public void setDataModel(org.richfaces.model.CalendarDataModel dataModel) {
        getStateHelper().put(Properties.dataModel, dataModel);
    }

 
    public String getDatePattern() {
        return (String) getStateHelper().eval(Properties.datePattern, "MMM d, yyyy");
    }
    
    public void setDatePattern(String datePattern) {
        getStateHelper().put(Properties.datePattern, datePattern);
    }

 
    public String getDayClassFunction() {
        return (String) getStateHelper().eval(Properties.dayClassFunction);
    }
    
    public void setDayClassFunction(String dayClassFunction) {
        getStateHelper().put(Properties.dayClassFunction, dayClassFunction);
    }

 
    public String getDayDisableFunction() {
        return (String) getStateHelper().eval(Properties.dayDisableFunction);
    }
    
    public void setDayDisableFunction(String dayDisableFunction) {
        getStateHelper().put(Properties.dayDisableFunction, dayDisableFunction);
    }

 
    public Object getDefaultTime() {
        return (Object) getStateHelper().eval(Properties.defaultTime, getDefaultValueOfDefaultTime(null,null));
    }
    
    public void setDefaultTime(Object defaultTime) {
        getStateHelper().put(Properties.defaultTime, defaultTime);
    }

 
    public String getDirection() {
        return (String) getStateHelper().eval(Properties.direction, "AA");
    }
    
    public void setDirection(String direction) {
        getStateHelper().put(Properties.direction, direction);
    }

 
    public boolean isDisabled() {
        return (Boolean) getStateHelper().eval(Properties.disabled, false);
    }
    
    public void setDisabled(boolean disabled) {
        getStateHelper().put(Properties.disabled, disabled);
    }

 
    public boolean isEnableManualInput() {
        return (Boolean) getStateHelper().eval(Properties.enableManualInput, false);
    }
    
    public void setEnableManualInput(boolean enableManualInput) {
        getStateHelper().put(Properties.enableManualInput, enableManualInput);
    }

 
    public int getFirstWeekDay() {
        return (Integer) getStateHelper().eval(Properties.firstWeekDay, Integer.MIN_VALUE);
    }
    
    public void setFirstWeekDay(int firstWeekDay) {
        getStateHelper().put(Properties.firstWeekDay, firstWeekDay);
    }

 
    public String getHidePopupOnScroll() {
        return (String) getStateHelper().eval(Properties.hidePopupOnScroll, "true");
    }
    
    public void setHidePopupOnScroll(String hidePopupOnScroll) {
        getStateHelper().put(Properties.hidePopupOnScroll, hidePopupOnScroll);
    }

 
    public int getHorizontalOffset() {
        return (Integer) getStateHelper().eval(Properties.horizontalOffset, 0);
    }
    
    public void setHorizontalOffset(int horizontalOffset) {
        getStateHelper().put(Properties.horizontalOffset, horizontalOffset);
    }

 
    public String getInputClass() {
        return (String) getStateHelper().eval(Properties.inputClass);
    }
    
    public void setInputClass(String inputClass) {
        getStateHelper().put(Properties.inputClass, inputClass);
    }

 
    public String getInputSize() {
        return (String) getStateHelper().eval(Properties.inputSize);
    }
    
    public void setInputSize(String inputSize) {
        getStateHelper().put(Properties.inputSize, inputSize);
    }

 
    public String getInputStyle() {
        return (String) getStateHelper().eval(Properties.inputStyle);
    }
    
    public void setInputStyle(String inputStyle) {
        getStateHelper().put(Properties.inputStyle, inputStyle);
    }

 
    public String getJointPoint() {
        return (String) getStateHelper().eval(Properties.jointPoint, "AA");
    }
    
    public void setJointPoint(String jointPoint) {
        getStateHelper().put(Properties.jointPoint, jointPoint);
    }

 
    public int getMinDaysInFirstWeek() {
        return (Integer) getStateHelper().eval(Properties.minDaysInFirstWeek, Integer.MIN_VALUE);
    }
    
    public void setMinDaysInFirstWeek(int minDaysInFirstWeek) {
        getStateHelper().put(Properties.minDaysInFirstWeek, minDaysInFirstWeek);
    }

 
    public String getMode() {
        return (String) getStateHelper().eval(Properties.mode, "client");
    }
    
    public void setMode(String mode) {
        getStateHelper().put(Properties.mode, mode);
    }

 
    public Object getMonthLabels() {
        return (Object) getStateHelper().eval(Properties.monthLabels);
    }
    
    public void setMonthLabels(Object monthLabels) {
        getStateHelper().put(Properties.monthLabels, monthLabels);
    }

 
    public Object getMonthLabelsShort() {
        return (Object) getStateHelper().eval(Properties.monthLabelsShort);
    }
    
    public void setMonthLabelsShort(Object monthLabelsShort) {
        getStateHelper().put(Properties.monthLabelsShort, monthLabelsShort);
    }

 
    public String getOnbeforecurrentdateselect() {
        return (String) getStateHelper().eval(Properties.onbeforecurrentdateselect);
    }
    
    public void setOnbeforecurrentdateselect(String onbeforecurrentdateselect) {
        getStateHelper().put(Properties.onbeforecurrentdateselect, onbeforecurrentdateselect);
    }

 
    public String getOnbeforedateselect() {
        return (String) getStateHelper().eval(Properties.onbeforedateselect);
    }
    
    public void setOnbeforedateselect(String onbeforedateselect) {
        getStateHelper().put(Properties.onbeforedateselect, onbeforedateselect);
    }

 
    public String getOnbeforetimeselect() {
        return (String) getStateHelper().eval(Properties.onbeforetimeselect);
    }
    
    public void setOnbeforetimeselect(String onbeforetimeselect) {
        getStateHelper().put(Properties.onbeforetimeselect, onbeforetimeselect);
    }

 
    public String getOnchange() {
        return (String) getStateHelper().eval(Properties.onchange);
    }
    
    public void setOnchange(String onchange) {
        getStateHelper().put(Properties.onchange, onchange);
    }

 
    public String getOnclean() {
        return (String) getStateHelper().eval(Properties.onclean);
    }
    
    public void setOnclean(String onclean) {
        getStateHelper().put(Properties.onclean, onclean);
    }

 
    public String getOncomplete() {
        return (String) getStateHelper().eval(Properties.oncomplete);
    }
    
    public void setOncomplete(String oncomplete) {
        getStateHelper().put(Properties.oncomplete, oncomplete);
    }

 
    public String getOncurrentdateselect() {
        return (String) getStateHelper().eval(Properties.oncurrentdateselect);
    }
    
    public void setOncurrentdateselect(String oncurrentdateselect) {
        getStateHelper().put(Properties.oncurrentdateselect, oncurrentdateselect);
    }

 
    public String getOndatemouseout() {
        return (String) getStateHelper().eval(Properties.ondatemouseout);
    }
    
    public void setOndatemouseout(String ondatemouseout) {
        getStateHelper().put(Properties.ondatemouseout, ondatemouseout);
    }

 
    public String getOndatemouseover() {
        return (String) getStateHelper().eval(Properties.ondatemouseover);
    }
    
    public void setOndatemouseover(String ondatemouseover) {
        getStateHelper().put(Properties.ondatemouseover, ondatemouseover);
    }

 
    public String getOndateselect() {
        return (String) getStateHelper().eval(Properties.ondateselect);
    }
    
    public void setOndateselect(String ondateselect) {
        getStateHelper().put(Properties.ondateselect, ondateselect);
    }

 
    public String getOnhide() {
        return (String) getStateHelper().eval(Properties.onhide);
    }
    
    public void setOnhide(String onhide) {
        getStateHelper().put(Properties.onhide, onhide);
    }

 
    public String getOninputblur() {
        return (String) getStateHelper().eval(Properties.oninputblur);
    }
    
    public void setOninputblur(String oninputblur) {
        getStateHelper().put(Properties.oninputblur, oninputblur);
    }

 
    public String getOninputchange() {
        return (String) getStateHelper().eval(Properties.oninputchange);
    }
    
    public void setOninputchange(String oninputchange) {
        getStateHelper().put(Properties.oninputchange, oninputchange);
    }

 
    public String getOninputclick() {
        return (String) getStateHelper().eval(Properties.oninputclick);
    }
    
    public void setOninputclick(String oninputclick) {
        getStateHelper().put(Properties.oninputclick, oninputclick);
    }

 
    public String getOninputdblclick() {
        return (String) getStateHelper().eval(Properties.oninputdblclick);
    }
    
    public void setOninputdblclick(String oninputdblclick) {
        getStateHelper().put(Properties.oninputdblclick, oninputdblclick);
    }

 
    public String getOninputfocus() {
        return (String) getStateHelper().eval(Properties.oninputfocus);
    }
    
    public void setOninputfocus(String oninputfocus) {
        getStateHelper().put(Properties.oninputfocus, oninputfocus);
    }

 
    public String getOninputkeydown() {
        return (String) getStateHelper().eval(Properties.oninputkeydown);
    }
    
    public void setOninputkeydown(String oninputkeydown) {
        getStateHelper().put(Properties.oninputkeydown, oninputkeydown);
    }

 
    public String getOninputkeypress() {
        return (String) getStateHelper().eval(Properties.oninputkeypress);
    }
    
    public void setOninputkeypress(String oninputkeypress) {
        getStateHelper().put(Properties.oninputkeypress, oninputkeypress);
    }

 
    public String getOninputkeyup() {
        return (String) getStateHelper().eval(Properties.oninputkeyup);
    }
    
    public void setOninputkeyup(String oninputkeyup) {
        getStateHelper().put(Properties.oninputkeyup, oninputkeyup);
    }

 
    public String getOninputmousedown() {
        return (String) getStateHelper().eval(Properties.oninputmousedown);
    }
    
    public void setOninputmousedown(String oninputmousedown) {
        getStateHelper().put(Properties.oninputmousedown, oninputmousedown);
    }

 
    public String getOninputmousemove() {
        return (String) getStateHelper().eval(Properties.oninputmousemove);
    }
    
    public void setOninputmousemove(String oninputmousemove) {
        getStateHelper().put(Properties.oninputmousemove, oninputmousemove);
    }

 
    public String getOninputmouseout() {
        return (String) getStateHelper().eval(Properties.oninputmouseout);
    }
    
    public void setOninputmouseout(String oninputmouseout) {
        getStateHelper().put(Properties.oninputmouseout, oninputmouseout);
    }

 
    public String getOninputmouseover() {
        return (String) getStateHelper().eval(Properties.oninputmouseover);
    }
    
    public void setOninputmouseover(String oninputmouseover) {
        getStateHelper().put(Properties.oninputmouseover, oninputmouseover);
    }

 
    public String getOninputmouseup() {
        return (String) getStateHelper().eval(Properties.oninputmouseup);
    }
    
    public void setOninputmouseup(String oninputmouseup) {
        getStateHelper().put(Properties.oninputmouseup, oninputmouseup);
    }

 
    public String getOninputselect() {
        return (String) getStateHelper().eval(Properties.oninputselect);
    }
    
    public void setOninputselect(String oninputselect) {
        getStateHelper().put(Properties.oninputselect, oninputselect);
    }

 
    public String getOnshow() {
        return (String) getStateHelper().eval(Properties.onshow);
    }
    
    public void setOnshow(String onshow) {
        getStateHelper().put(Properties.onshow, onshow);
    }

 
    public String getOntimeselect() {
        return (String) getStateHelper().eval(Properties.ontimeselect);
    }
    
    public void setOntimeselect(String ontimeselect) {
        getStateHelper().put(Properties.ontimeselect, ontimeselect);
    }

 
    public boolean isPopup() {
        return (Boolean) getStateHelper().eval(Properties.popup, true);
    }
    
    public void setPopup(boolean popup) {
        getStateHelper().put(Properties.popup, popup);
    }

 
    public Object getPreloadDateRangeBegin() {
        return (Object) getStateHelper().eval(Properties.preloadDateRangeBegin, getDefaultPreloadBegin(getCurrentDateOrDefault()));
    }
    
    public void setPreloadDateRangeBegin(Object preloadDateRangeBegin) {
        getStateHelper().put(Properties.preloadDateRangeBegin, preloadDateRangeBegin);
    }

 
    public Object getPreloadDateRangeEnd() {
        return (Object) getStateHelper().eval(Properties.preloadDateRangeEnd, getDefaultPreloadEnd(getCurrentDateOrDefault()));
    }
    
    public void setPreloadDateRangeEnd(Object preloadDateRangeEnd) {
        getStateHelper().put(Properties.preloadDateRangeEnd, preloadDateRangeEnd);
    }

 
    public boolean isResetTimeOnDateSelect() {
        return (Boolean) getStateHelper().eval(Properties.resetTimeOnDateSelect, false);
    }
    
    public void setResetTimeOnDateSelect(boolean resetTimeOnDateSelect) {
        getStateHelper().put(Properties.resetTimeOnDateSelect, resetTimeOnDateSelect);
    }

 
    public boolean isShowApplyButton() {
        return (Boolean) getStateHelper().eval(Properties.showApplyButton, false);
    }
    
    public void setShowApplyButton(boolean showApplyButton) {
        getStateHelper().put(Properties.showApplyButton, showApplyButton);
    }

 
    public boolean isShowFooter() {
        return (Boolean) getStateHelper().eval(Properties.showFooter, true);
    }
    
    public void setShowFooter(boolean showFooter) {
        getStateHelper().put(Properties.showFooter, showFooter);
    }

 
    public boolean isShowHeader() {
        return (Boolean) getStateHelper().eval(Properties.showHeader, true);
    }
    
    public void setShowHeader(boolean showHeader) {
        getStateHelper().put(Properties.showHeader, showHeader);
    }

 
    public boolean isShowInput() {
        return (Boolean) getStateHelper().eval(Properties.showInput, true);
    }
    
    public void setShowInput(boolean showInput) {
        getStateHelper().put(Properties.showInput, showInput);
    }

 
    public boolean isShowWeekDaysBar() {
        return (Boolean) getStateHelper().eval(Properties.showWeekDaysBar, true);
    }
    
    public void setShowWeekDaysBar(boolean showWeekDaysBar) {
        getStateHelper().put(Properties.showWeekDaysBar, showWeekDaysBar);
    }

 
    public boolean isShowWeeksBar() {
        return (Boolean) getStateHelper().eval(Properties.showWeeksBar, true);
    }
    
    public void setShowWeeksBar(boolean showWeeksBar) {
        getStateHelper().put(Properties.showWeeksBar, showWeeksBar);
    }

 
    public String getStyle() {
        return (String) getStateHelper().eval(Properties.style);
    }
    
    public void setStyle(String style) {
        getStateHelper().put(Properties.style, style);
    }

 
    public String getTabindex() {
        return (String) getStateHelper().eval(Properties.tabindex);
    }
    
    public void setTabindex(String tabindex) {
        getStateHelper().put(Properties.tabindex, tabindex);
    }

 
    public java.util.TimeZone getTimeZone() {
        return (TimeZone) getStateHelper().eval(Properties.timeZone, TimeZone.getDefault());
    }
    
    public void setTimeZone(java.util.TimeZone timeZone) {
        getStateHelper().put(Properties.timeZone, timeZone);
    }

 
    public String getTodayControlMode() {
        return (String) getStateHelper().eval(Properties.todayControlMode, "select");
    }
    
    public void setTodayControlMode(String todayControlMode) {
        getStateHelper().put(Properties.todayControlMode, todayControlMode);
    }

 
    public int getVerticalOffset() {
        return (Integer) getStateHelper().eval(Properties.verticalOffset, 0);
    }
    
    public void setVerticalOffset(int verticalOffset) {
        getStateHelper().put(Properties.verticalOffset, verticalOffset);
    }

 
    public Object getWeekDayLabels() {
        return (Object) getStateHelper().eval(Properties.weekDayLabels);
    }
    
    public void setWeekDayLabels(Object weekDayLabels) {
        getStateHelper().put(Properties.weekDayLabels, weekDayLabels);
    }

 
    public Object getWeekDayLabelsShort() {
        return (Object) getStateHelper().eval(Properties.weekDayLabelsShort);
    }
    
    public void setWeekDayLabelsShort(Object weekDayLabelsShort) {
        getStateHelper().put(Properties.weekDayLabelsShort, weekDayLabelsShort);
    }

 
    public int getZindex() {
        return (Integer) getStateHelper().eval(Properties.zindex, 3);
    }
    
    public void setZindex(int zindex) {
        getStateHelper().put(Properties.zindex, zindex);
    }

}