/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractTree;
import org.richfaces.component.SwitchType;

/**
 *  @author Nick Belaevski
 

 **/
@Generated({"RichFaces CDK", "4.0.0-SNAPSHOT"})
public class UITree extends AbstractTree
    implements ClientBehaviorHolder
    {

    public static final String COMPONENT_TYPE="org.richfaces.Tree";

    public static final String COMPONENT_FAMILY="org.richfaces.Tree";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public UITree() {
        super();
        setRendererType("org.richfaces.TreeRenderer");
    }

    private static final Collection<String> EVENT_NAMES = Collections.unmodifiableCollection(Arrays.asList(
        "keyup",
        "mousedown",
        "click",
        "beforenodetoggle",
        "mouseover",
        "selectionchange",
        "nodetoggle",
        "begin",
        "mousemove",
        "beforeselectionchange",
        "keydown",
        "mouseout",
        "beforedomupdate",
        "keypress",
        "complete",
        "dblclick",
        "mouseup"

        ));
    
    public Collection<String> getEventNames() {
        return EVENT_NAMES;
    }


    public String getDefaultEventName() {
        return null;
    }

    protected static enum Properties {
        execute,
        handleClass,
        iconClass,
        iconCollapsed,
        iconExpanded,
        iconLeaf,
        immediate,
        labelClass,
        limitRender,
        nodeClass,
        nodeType,
        onbeforedomupdate,
        onbeforenodetoggle,
        onbeforeselectionchange,
        onbegin,
        oncomplete,
        onnodetoggle,
        onselectionchange,
        render,
        selectionType,
        status,
        toggleNodeEvent,
        toggleType,
        value

    }


 
    public Object getExecute() {
        return (Object) getStateHelper().eval(Properties.execute);
    }
    
    public void setExecute(Object execute) {
        getStateHelper().put(Properties.execute, execute);
    }

 
    public String getHandleClass() {
        return (String) getStateHelper().eval(Properties.handleClass);
    }
    
    public void setHandleClass(String handleClass) {
        getStateHelper().put(Properties.handleClass, handleClass);
    }

 
    public String getIconClass() {
        return (String) getStateHelper().eval(Properties.iconClass);
    }
    
    public void setIconClass(String iconClass) {
        getStateHelper().put(Properties.iconClass, iconClass);
    }

 
    public String getIconCollapsed() {
        return (String) getStateHelper().eval(Properties.iconCollapsed);
    }
    
    public void setIconCollapsed(String iconCollapsed) {
        getStateHelper().put(Properties.iconCollapsed, iconCollapsed);
    }

 
    public String getIconExpanded() {
        return (String) getStateHelper().eval(Properties.iconExpanded);
    }
    
    public void setIconExpanded(String iconExpanded) {
        getStateHelper().put(Properties.iconExpanded, iconExpanded);
    }

 
    public String getIconLeaf() {
        return (String) getStateHelper().eval(Properties.iconLeaf);
    }
    
    public void setIconLeaf(String iconLeaf) {
        getStateHelper().put(Properties.iconLeaf, iconLeaf);
    }

 
    public boolean isImmediate() {
        return (Boolean) getStateHelper().eval(Properties.immediate, false);
    }
    
    public void setImmediate(boolean immediate) {
        getStateHelper().put(Properties.immediate, immediate);
    }

 
    public String getLabelClass() {
        return (String) getStateHelper().eval(Properties.labelClass);
    }
    
    public void setLabelClass(String labelClass) {
        getStateHelper().put(Properties.labelClass, labelClass);
    }

 
    public boolean isLimitRender() {
        return (Boolean) getStateHelper().eval(Properties.limitRender, false);
    }
    
    public void setLimitRender(boolean limitRender) {
        getStateHelper().put(Properties.limitRender, limitRender);
    }

 
    public String getNodeClass() {
        return (String) getStateHelper().eval(Properties.nodeClass);
    }
    
    public void setNodeClass(String nodeClass) {
        getStateHelper().put(Properties.nodeClass, nodeClass);
    }

 
    public String getNodeType() {
        return (String) getStateHelper().eval(Properties.nodeType);
    }
    
    public void setNodeType(String nodeType) {
        getStateHelper().put(Properties.nodeType, nodeType);
    }

 
    public String getOnbeforedomupdate() {
        return (String) getStateHelper().eval(Properties.onbeforedomupdate);
    }
    
    public void setOnbeforedomupdate(String onbeforedomupdate) {
        getStateHelper().put(Properties.onbeforedomupdate, onbeforedomupdate);
    }

 
    public String getOnbeforenodetoggle() {
        return (String) getStateHelper().eval(Properties.onbeforenodetoggle);
    }
    
    public void setOnbeforenodetoggle(String onbeforenodetoggle) {
        getStateHelper().put(Properties.onbeforenodetoggle, onbeforenodetoggle);
    }

 
    public String getOnbeforeselectionchange() {
        return (String) getStateHelper().eval(Properties.onbeforeselectionchange);
    }
    
    public void setOnbeforeselectionchange(String onbeforeselectionchange) {
        getStateHelper().put(Properties.onbeforeselectionchange, onbeforeselectionchange);
    }

 
    public String getOnbegin() {
        return (String) getStateHelper().eval(Properties.onbegin);
    }
    
    public void setOnbegin(String onbegin) {
        getStateHelper().put(Properties.onbegin, onbegin);
    }

 
    public String getOncomplete() {
        return (String) getStateHelper().eval(Properties.oncomplete);
    }
    
    public void setOncomplete(String oncomplete) {
        getStateHelper().put(Properties.oncomplete, oncomplete);
    }

 
    public String getOnnodetoggle() {
        return (String) getStateHelper().eval(Properties.onnodetoggle);
    }
    
    public void setOnnodetoggle(String onnodetoggle) {
        getStateHelper().put(Properties.onnodetoggle, onnodetoggle);
    }

 
    public String getOnselectionchange() {
        return (String) getStateHelper().eval(Properties.onselectionchange);
    }
    
    public void setOnselectionchange(String onselectionchange) {
        getStateHelper().put(Properties.onselectionchange, onselectionchange);
    }

 
    public Object getRender() {
        return (Object) getStateHelper().eval(Properties.render);
    }
    
    public void setRender(Object render) {
        getStateHelper().put(Properties.render, render);
    }

 
    public org.richfaces.component.SwitchType getSelectionType() {
        return (SwitchType) getStateHelper().eval(Properties.selectionType, SwitchType.client);
    }
    
    public void setSelectionType(org.richfaces.component.SwitchType selectionType) {
        getStateHelper().put(Properties.selectionType, selectionType);
    }

 
    public String getStatus() {
        return (String) getStateHelper().eval(Properties.status);
    }
    
    public void setStatus(String status) {
        getStateHelper().put(Properties.status, status);
    }

 
    public String getToggleNodeEvent() {
        return (String) getStateHelper().eval(Properties.toggleNodeEvent);
    }
    
    public void setToggleNodeEvent(String toggleNodeEvent) {
        getStateHelper().put(Properties.toggleNodeEvent, toggleNodeEvent);
    }

 
    public org.richfaces.component.SwitchType getToggleType() {
        return (SwitchType) getStateHelper().eval(Properties.toggleType, SwitchType.DEFAULT);
    }
    
    public void setToggleType(org.richfaces.component.SwitchType toggleType) {
        getStateHelper().put(Properties.toggleType, toggleType);
    }

 
    public Object getValue() {
        return (Object) getStateHelper().eval(Properties.value);
    }
    
    public void setValue(Object value) {
        getStateHelper().put(Properties.value, value);
    }

}