/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractTreeNode;

/**
 *  @author Nick Belaevski
 

 **/
@Generated({"RichFaces CDK", "4.0.0-SNAPSHOT"})
public class UITreeNode extends AbstractTreeNode
    implements ClientBehaviorHolder
    {

    public static final String COMPONENT_TYPE="org.richfaces.TreeNode";

    public static final String COMPONENT_FAMILY="org.richfaces.TreeNode";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public UITreeNode() {
        super();
        setRendererType("org.richfaces.TreeNodeRenderer");
    }

    private static final Collection<String> EVENT_NAMES = Collections.unmodifiableCollection(Arrays.asList(
        "keypress",
        "mousedown",
        "keyup",
        "beforetoggle",
        "dblclick",
        "click",
        "toggle",
        "mouseover",
        "mousemove",
        "mouseout",
        "keydown",
        "mouseup"

        ));
    
    public Collection<String> getEventNames() {
        return EVENT_NAMES;
    }


    public String getDefaultEventName() {
        return null;
    }

    protected static enum Properties {
        handleClass,
        iconClass,
        iconCollapsed,
        iconExpanded,
        iconLeaf,
        immediate,
        labelClass,
        onbeforetoggle,
        ontoggle,
        type

    }


 
    public String getHandleClass() {
        return (String) getStateHelper().eval(Properties.handleClass);
    }
    
    public void setHandleClass(String handleClass) {
        getStateHelper().put(Properties.handleClass, handleClass);
    }

 
    public String getIconClass() {
        return (String) getStateHelper().eval(Properties.iconClass);
    }
    
    public void setIconClass(String iconClass) {
        getStateHelper().put(Properties.iconClass, iconClass);
    }

 
    public String getIconCollapsed() {
        return (String) getStateHelper().eval(Properties.iconCollapsed);
    }
    
    public void setIconCollapsed(String iconCollapsed) {
        getStateHelper().put(Properties.iconCollapsed, iconCollapsed);
    }

 
    public String getIconExpanded() {
        return (String) getStateHelper().eval(Properties.iconExpanded);
    }
    
    public void setIconExpanded(String iconExpanded) {
        getStateHelper().put(Properties.iconExpanded, iconExpanded);
    }

 
    public String getIconLeaf() {
        return (String) getStateHelper().eval(Properties.iconLeaf);
    }
    
    public void setIconLeaf(String iconLeaf) {
        getStateHelper().put(Properties.iconLeaf, iconLeaf);
    }

 
    public boolean isImmediate() {
        return (Boolean) getStateHelper().eval(Properties.immediate, findTreeComponent().isImmediate());
    }
    
    public void setImmediate(boolean immediate) {
        getStateHelper().put(Properties.immediate, immediate);
    }

 
    public String getLabelClass() {
        return (String) getStateHelper().eval(Properties.labelClass);
    }
    
    public void setLabelClass(String labelClass) {
        getStateHelper().put(Properties.labelClass, labelClass);
    }

 
    public String getOnbeforetoggle() {
        return (String) getStateHelper().eval(Properties.onbeforetoggle);
    }
    
    public void setOnbeforetoggle(String onbeforetoggle) {
        getStateHelper().put(Properties.onbeforetoggle, onbeforetoggle);
    }

 
    public String getOntoggle() {
        return (String) getStateHelper().eval(Properties.ontoggle);
    }
    
    public void setOntoggle(String ontoggle) {
        getStateHelper().put(Properties.ontoggle, ontoggle);
    }

 
    public String getType() {
        return (String) getStateHelper().eval(Properties.type);
    }
    
    public void setType(String type) {
        getStateHelper().put(Properties.type, type);
    }

}